// Code generated by bpf2go; DO NOT EDIT.
//go:build 386 || amd64 || amd64p32 || arm || arm64 || mips64le || mips64p32le || mipsle || ppc64le || riscv64
// +build 386 amd64 amd64p32 arm arm64 mips64le mips64p32le mipsle ppc64le riscv64

package main

import (
	"bytes"
	_ "embed"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

// LoadKProbeMultiPWRU returns the embedded CollectionSpec for KProbeMultiPWRU.
func LoadKProbeMultiPWRU() (*ebpf.CollectionSpec, error) {
	reader := bytes.NewReader(_KProbeMultiPWRUBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load KProbeMultiPWRU: %w", err)
	}

	return spec, err
}

// LoadKProbeMultiPWRUObjects loads KProbeMultiPWRU and converts it into a struct.
//
// The following types are suitable as obj argument:
//
//	*KProbeMultiPWRUObjects
//	*KProbeMultiPWRUPrograms
//	*KProbeMultiPWRUMaps
//
// See ebpf.CollectionSpec.LoadAndAssign documentation for details.
func LoadKProbeMultiPWRUObjects(obj interface{}, opts *ebpf.CollectionOptions) error {
	spec, err := LoadKProbeMultiPWRU()
	if err != nil {
		return err
	}

	return spec.LoadAndAssign(obj, opts)
}

// KProbeMultiPWRUSpecs contains maps and programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbeMultiPWRUSpecs struct {
	KProbeMultiPWRUProgramSpecs
	KProbeMultiPWRUMapSpecs
}

// KProbeMultiPWRUSpecs contains programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbeMultiPWRUProgramSpecs struct {
	KprobeSkb1 *ebpf.ProgramSpec `ebpf:"kprobe_skb_1"`
	KprobeSkb2 *ebpf.ProgramSpec `ebpf:"kprobe_skb_2"`
	KprobeSkb3 *ebpf.ProgramSpec `ebpf:"kprobe_skb_3"`
	KprobeSkb4 *ebpf.ProgramSpec `ebpf:"kprobe_skb_4"`
	KprobeSkb5 *ebpf.ProgramSpec `ebpf:"kprobe_skb_5"`
}

// KProbeMultiPWRUMapSpecs contains maps before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbeMultiPWRUMapSpecs struct {
	Events        *ebpf.MapSpec `ebpf:"events"`
	PrintSkbMap   *ebpf.MapSpec `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.MapSpec `ebpf:"print_stack_map"`
}

// KProbeMultiPWRUObjects contains all objects after they have been loaded into the kernel.
//
// It can be passed to LoadKProbeMultiPWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbeMultiPWRUObjects struct {
	KProbeMultiPWRUPrograms
	KProbeMultiPWRUMaps
}

func (o *KProbeMultiPWRUObjects) Close() error {
	return _KProbeMultiPWRUClose(
		&o.KProbeMultiPWRUPrograms,
		&o.KProbeMultiPWRUMaps,
	)
}

// KProbeMultiPWRUMaps contains all maps after they have been loaded into the kernel.
//
// It can be passed to LoadKProbeMultiPWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbeMultiPWRUMaps struct {
	Events        *ebpf.Map `ebpf:"events"`
	PrintSkbMap   *ebpf.Map `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.Map `ebpf:"print_stack_map"`
}

func (m *KProbeMultiPWRUMaps) Close() error {
	return _KProbeMultiPWRUClose(
		m.Events,
		m.PrintSkbMap,
		m.PrintStackMap,
	)
}

// KProbeMultiPWRUPrograms contains all programs after they have been loaded into the kernel.
//
// It can be passed to LoadKProbeMultiPWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbeMultiPWRUPrograms struct {
	KprobeSkb1 *ebpf.Program `ebpf:"kprobe_skb_1"`
	KprobeSkb2 *ebpf.Program `ebpf:"kprobe_skb_2"`
	KprobeSkb3 *ebpf.Program `ebpf:"kprobe_skb_3"`
	KprobeSkb4 *ebpf.Program `ebpf:"kprobe_skb_4"`
	KprobeSkb5 *ebpf.Program `ebpf:"kprobe_skb_5"`
}

func (p *KProbeMultiPWRUPrograms) Close() error {
	return _KProbeMultiPWRUClose(
		p.KprobeSkb1,
		p.KprobeSkb2,
		p.KprobeSkb3,
		p.KprobeSkb4,
		p.KprobeSkb5,
	)
}

func _KProbeMultiPWRUClose(closers ...io.Closer) error {
	for _, closer := range closers {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
//
//go:embed kprobemultipwru_bpfel.o
var _KProbeMultiPWRUBytes []byte
