// Code generated by bpf2go; DO NOT EDIT.
//go:build 386 || amd64 || amd64p32 || arm || arm64 || mips64le || mips64p32le || mipsle || ppc64le || riscv64
// +build 386 amd64 amd64p32 arm arm64 mips64le mips64p32le mipsle ppc64le riscv64

package main

import (
	"bytes"
	_ "embed"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

// LoadKProbePWRU returns the embedded CollectionSpec for KProbePWRU.
func LoadKProbePWRU() (*ebpf.CollectionSpec, error) {
	reader := bytes.NewReader(_KProbePWRUBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load KProbePWRU: %w", err)
	}

	return spec, err
}

// LoadKProbePWRUObjects loads KProbePWRU and converts it into a struct.
//
// The following types are suitable as obj argument:
//
//	*KProbePWRUObjects
//	*KProbePWRUPrograms
//	*KProbePWRUMaps
//
// See ebpf.CollectionSpec.LoadAndAssign documentation for details.
func LoadKProbePWRUObjects(obj interface{}, opts *ebpf.CollectionOptions) error {
	spec, err := LoadKProbePWRU()
	if err != nil {
		return err
	}

	return spec.LoadAndAssign(obj, opts)
}

// KProbePWRUSpecs contains maps and programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUSpecs struct {
	KProbePWRUProgramSpecs
	KProbePWRUMapSpecs
}

// KProbePWRUSpecs contains programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUProgramSpecs struct {
	KprobeSkb1 *ebpf.ProgramSpec `ebpf:"kprobe_skb_1"`
	KprobeSkb2 *ebpf.ProgramSpec `ebpf:"kprobe_skb_2"`
	KprobeSkb3 *ebpf.ProgramSpec `ebpf:"kprobe_skb_3"`
	KprobeSkb4 *ebpf.ProgramSpec `ebpf:"kprobe_skb_4"`
	KprobeSkb5 *ebpf.ProgramSpec `ebpf:"kprobe_skb_5"`
}

// KProbePWRUMapSpecs contains maps before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUMapSpecs struct {
	Events        *ebpf.MapSpec `ebpf:"events"`
	PrintSkbMap   *ebpf.MapSpec `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.MapSpec `ebpf:"print_stack_map"`
}

// KProbePWRUObjects contains all objects after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUObjects struct {
	KProbePWRUPrograms
	KProbePWRUMaps
}

func (o *KProbePWRUObjects) Close() error {
	return _KProbePWRUClose(
		&o.KProbePWRUPrograms,
		&o.KProbePWRUMaps,
	)
}

// KProbePWRUMaps contains all maps after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUMaps struct {
	Events        *ebpf.Map `ebpf:"events"`
	PrintSkbMap   *ebpf.Map `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.Map `ebpf:"print_stack_map"`
}

func (m *KProbePWRUMaps) Close() error {
	return _KProbePWRUClose(
		m.Events,
		m.PrintSkbMap,
		m.PrintStackMap,
	)
}

// KProbePWRUPrograms contains all programs after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUPrograms struct {
	KprobeSkb1 *ebpf.Program `ebpf:"kprobe_skb_1"`
	KprobeSkb2 *ebpf.Program `ebpf:"kprobe_skb_2"`
	KprobeSkb3 *ebpf.Program `ebpf:"kprobe_skb_3"`
	KprobeSkb4 *ebpf.Program `ebpf:"kprobe_skb_4"`
	KprobeSkb5 *ebpf.Program `ebpf:"kprobe_skb_5"`
}

func (p *KProbePWRUPrograms) Close() error {
	return _KProbePWRUClose(
		p.KprobeSkb1,
		p.KprobeSkb2,
		p.KprobeSkb3,
		p.KprobeSkb4,
		p.KprobeSkb5,
	)
}

func _KProbePWRUClose(closers ...io.Closer) error {
	for _, closer := range closers {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
//
//go:embed kprobepwru_bpfel.o
var _KProbePWRUBytes []byte
